                                ; store screen
    ld hl,$FC00
    ld de,scrbuf+DIFF
    ld bc,1024
    ldir
                                ; hide cursor and check if it's on top row
    res 2,(iy+12)
    ld a,(_curRow)
    and a
    jr nz,huh
                                ; if it is, move it down with the whole top row
    ld h,$FC
    ld de,scrbuf+DIFF+128
    ld c,112
    ldir
    inc a
    ld (_curRow),a
                                ; moving textshadow too.
    ld hl,$C0F9
    ld de,$C0F9+21
    ld bc,21
    ldir
huh:
    call _clrLCD
                                ; get 2ND-button state
    ld a,%00111111
    out (1),a
    in a,(1)
    bit 5,a
    jr nz,jooha ; if jumping, a can't be zero
    xor a       ; now a is zero
jooha:
    ld (nopassset+1),a
                                ; wait until all keys released
gloop3:
    call GET_KEY
    and a
    jr nz,gloop3
                                ; look for fortunes-file
    ld hl,name+1
    ld (hl),8
    dec hl
    rst 20h
    rst 10h
    ld hl,$FC00
    jp c,exit
                                ; get address from BDE to AHL
    ex de,hl
    in a,(6)                    ; get current RAM page
    push af                     ; push it
    in a,(5)                    ; get current ROM page
    push af                     ; push it twice
    push af
    ld a,b
                                ; translate virtual memory address and set mem pages
    call $4633
    set 6,a
    out (5),a
    ld (setROMPage+1),a
    inc a
    out (6),a
    ld d,-$40
    add hl,de
    pop af                      ; now old ROM page only once in stack.
    ld d,a                      ; put old ROM page in D
                                ; get file size
    ld c,(hl)
    inc hl
    ld b,(hl)
    push bc                     ; push file size
                                ; move to beginning
    inc hl                      ; hl points to type...
    inc hl                      ; hl points to fortune data.
    push hl                     ; push fortune start address

                                ; look for $d6s (new lines) and count them
    ld e,-1
    ld a,$d6
looppah:
    inc e
    cpir
    jr z,looppah
                                ; return to old rom page
    ld a,d                      ; new ROM page in D!
    out (5),a
                                ; get a random line number
    push de                     ; push line count (E) and crap (D)
    call _RANDOM ; get number between 0 and 1
    pop hl                      ; now line count in L
    ld h,0                      ;         -"-       HL
    call _setxxxxop2            ; put hl into OP2

    rst 28h                     ; multiply
    call _convop1               ; get result to E

    pop hl                      ; pop fortune start address
    pop bc                      ; pop file size

    dec bc

setROMPage:
    ld a,0                      ; set ROM page again (self modify)
    out (5),a
                                ; find correct line
    ld a,e
    and a
    jr z,puis
looppa:
    ld a,$d6
    cpir
    jr nz,puis

    dec e
    jr nz,looppa
puis:

    ld de,scrbuf+1024+DIFF
mumm:
    ld a,(hl)
    cp $D6
    jr z,argh
    cp $B9
    jr nz,nohuh
    xor a
nohuh:
    ld (de),a
    inc hl
    inc de
    jr mumm
argh:
    xor a
    ld (de),a
    inc de
    ld (de),a

revertROMPage2:
    pop af                      ; old ROM page no longer in stack
    out (5),a

;    ld a,(_curRow)
;    push af
;    call _clrLCD

    ld de,1
    ld hl,scrbuf+1024+DIFF
;    ld bc,$FF
    ld bc,$00

; *** show line ***
ploop:
    push bc
    push hl
    ld (_penCol),de
    call _vputs
    ld hl,7*$100
    add hl,de
    ex de,hl
    pop hl
    xor a
    cpir
    pop bc
    inc b
    cp (hl)
    jr nz,ploop













    ld hl,$FC00
invlooppi:
    ld c,b
    ld b,112
joopap:
    ld a,(hl)
    cpl
    ld (hl),a
    inc hl
    djnz joopap
    ld b,c
    djnz invlooppi

    pop af                      ; old RAM page no longer in stack
    out (6),a
exit:
    push hl                     ; push address to end of shaded area
    ld c,b                      ; c=0

    ld a,(woid)
    cp K_ENTER
    jr z,nopassset
; *** check password ***
passset:
    ld hl,28*$100+1
    ld (_penCol),hl
    ld hl,pass
    call _vputs

    ld b,8
    ld hl,$C0CC
hmnh3:

    res 3,(iy+$23)
    push hl
    push bc
gloopp1:
    call GET_KEY
    and a
    jr nz,gloopp1
gloopp2:
    call GET_KEY
    and a
    jr z,gloopp2
    pop bc
    pop hl
    set 3,(iy+$23)


    ld (hl),a
    inc hl
    inc c

    cp K_ENTER
    jr z,check
    ld a,'*'
    call _vputmap
    djnz hmnh3

check:
    ld b,c
    ld l,$CC
    ld de,woid

hmnh4:
    ld a,(de)
    cp (hl)
    jr z,oikein
    xor a
    inc a
    out (3),a
    halt
    ld a,11
    out (3),a
    pop de
    jp huh
oikein:
    inc hl
    inc de
    djnz hmnh4

nopassset:
    ld a,0                      ; self modify...
    and a                       ; 2ND state STILL in C!
    jr nz,nosettings
    ld hl,name+1
    ld (hl),7
    dec hl
    rst 20h
    ld a,42
    call _exec_assembly
nosettings:
    pop de

    ld a,d ; bc=-de
    cpl
    ld b,a
    ld a,e
    cpl
    ld c,a

    ld hl,(scrbuf+DIFF)-$FC00 ; ruutu takas
    add hl,de
    ldir
    set 2,(iy+12) ; kursori esiin
    ret




pass:
    .db "paz: "
name:
    .db 0,8,"fortunes"
woid:
    .db K_ENTER,0,0,0,0,0,0,0
